package foedselsnummer.fnummer;

import datetimedatetime.DateCalculations.datetimeDate;
import references.references.NumberReference;
import references.references.StringReference;

import static charCharacters.Characters.Characters.charIsNumber;
import static datetimedatetime.DateCalculations.DateCalculations.datetimeIsValidDate;
import static nnumbers.StringToNumber.StringToNumber.nGetNumberFromNumberCharacterForBase;
import static references.references.references.CreateNumberReference;
import static references.references.references.CreateStringReference;

public class fnummer {
    public static boolean IsValidNorwegianPersonalIdentificationNumber(char [] fnummer){
        boolean gyldig;
        double d1, d2, d3, d4, d5, d6, d7, d8, d9, d10, d11;
        datetimeDate aDatetimeDate;
        double k1, k2;
        NumberReference failures;
        StringReference errorMessage;

        errorMessage = CreateStringReference("".toCharArray());

        if(fnummer.length == 11d){
            failures = CreateNumberReference(0d);

            d1 = CharToNumberWithCheck(fnummer[0], failures);
            d2 = CharToNumberWithCheck(fnummer[1], failures);
            d3 = CharToNumberWithCheck(fnummer[2], failures);
            d4 = CharToNumberWithCheck(fnummer[3], failures);
            d5 = CharToNumberWithCheck(fnummer[4], failures);
            d6 = CharToNumberWithCheck(fnummer[5], failures);
            d7 = CharToNumberWithCheck(fnummer[6], failures);
            d8 = CharToNumberWithCheck(fnummer[7], failures);
            d9 = CharToNumberWithCheck(fnummer[8], failures);
            d10 = CharToNumberWithCheck(fnummer[9], failures);
            d11 = CharToNumberWithCheck(fnummer[10], failures);

            if(failures.numberValue == 0d) {
                aDatetimeDate = GetDateFromNorwegianPersonalIdentificationNumber(fnummer, failures);

                if(datetimeIsValidDate(aDatetimeDate, errorMessage)){
                    if(failures.numberValue == 0d) {
                        k1 = d1*3d + d2*7d + d3*6d + d4*1d + d5*8d + d6*9d + d7*4d + d8*5d + d9*2d;
                        k1 = k1 % 11d;
                        if(k1 != 0d){
                            k1 = 11d - k1;
                        }
                        if(k1 == 10d){
                            failures.numberValue = failures.numberValue + 1d;
                        }

                        k2 = d1*5d + d2*4d + d3*3d + d4*2d + d5*7d + d6*6d + d7*5d + d8*4d + d9*3d + k1*2d;
                        k2 = k2 % 11d;
                        if(k2 != 0d){
                            k2 = 11d - k2;
                        }
                        if(k2 == 10d){
                            failures.numberValue = failures.numberValue + 1d;
                        }

                        if(k1 == d10 && k2 == d11 && failures.numberValue == 0d){
                            gyldig = true;
                        }else{
                            gyldig = false;
                        }
                    }else{
                        gyldig = false;
                    }
                } else {
                    gyldig = false;
                }
            } else {
                gyldig = false;
            }
        }else{
            gyldig = false;
        }

        return gyldig;
    }

    public static datetimeDate GetDateFromNorwegianPersonalIdentificationNumber(char[] fnummer, NumberReference failures){
        datetimeDate aDatetimeDate;
        double individnummer;
        double day, month, year;
        double d1, d2, d3, d4, d5, d6, d7, d8, d9;

        aDatetimeDate = new datetimeDate();

        d1 = CharToNumberWithCheck(fnummer[0], failures);
        d2 = CharToNumberWithCheck(fnummer[1], failures);
        d3 = CharToNumberWithCheck(fnummer[2], failures);
        d4 = CharToNumberWithCheck(fnummer[3], failures);
        d5 = CharToNumberWithCheck(fnummer[4], failures);
        d6 = CharToNumberWithCheck(fnummer[5], failures);
        d7 = CharToNumberWithCheck(fnummer[6], failures);
        d8 = CharToNumberWithCheck(fnummer[7], failures);
        d9 = CharToNumberWithCheck(fnummer[8], failures);

        if(failures.numberValue == 0d) {
            // Individnummer
            individnummer = d7 * 100d + d8 * 10d + d9;

            // Make date
            day = d1 * 10d + d2;
            month = d3 * 10d + d4;
            year = d5 * 10d + d6;

            if (individnummer >= 0d && individnummer <= 499d) {
                year = year + 1900d;
            } else if (individnummer >= 500d && individnummer <= 749d && year >= 54d && year <= 99d) {
                year = year + 1800d;
            } else if (individnummer >= 900d && individnummer <= 999d && year >= 40d && year <= 99d) {
                year = year + 1900d;
            } else if (individnummer >= 500d && individnummer <= 999d && year >= 0d && year <= 39d) {
                year = year + 1900d;
            } else {
                failures.numberValue = failures.numberValue + 1d;
            }

            aDatetimeDate.year = year;
            aDatetimeDate.month = month;
            aDatetimeDate.day = day;
        }

        return aDatetimeDate;
    }

    public static double CharToNumberWithCheck(char c, NumberReference failures){
        double val;

        if(charIsNumber(c)){
            val = nGetNumberFromNumberCharacterForBase(c, 10d);
        }else{
            val = 0d;
            failures.numberValue = failures.numberValue + 1d;
        }

        return val;
    }
}
